# SuperEdge Governance

The following document outlines how the SuperEdge project governance works.

* [SuperEdge Governance](#superedge-governance)
   * [Principle](#principle)
   * [Project manager](#project-manager)
   * [How to become a SuperEdge operator](#how-to-become-a-superedge-operator)
   * [Other projects](#other-projects)
   * [SuperEdge and CNCF](#superedge-and-cncf)
   * [Code of Conduct](#code-of-conduct)

## Principle

The SuperEdge community follows the following principles:

-   Open: SuperEdge is completely open source, and there are corresponding instructions on [our website](https://superedge.io/).
-   Respect: SuperEdge welcomes and respects every contributor and user, and treats everyone equally;
-   Transparency: Changes to the SuperEdge organization, SuperEdge code repository, and CNCF-related activities (such as levels, participation, etc.) are made publicly.
-   Pursue excellence: accept ideas and contributions based on its technical advantages and consistency with project goals, scope and design principles, and give priority to ideas that can solve users' real problems.

## Project manager

The SuperEdge project has 2~3 project leaders and influencers who are responsible for SuperEdge's current large and small business decisions. For the current relevant leaders, please see [OWNERS](https://github.com/superedge/superedge/blob/main/OWNERS);

The project leader in SuperEdge has the final right to make any decisions about the SuperEdge project.

The project leader is selected by the SuperEdge maintainers based on their personal contributions to the SuperEdge project. The project leader has a one-year term with no term limit.

## How to become a SuperEdge operator

-   Become a maintainer

    After you have contributed more than 5 PRs, you can contact the project leader to see if you can become a SuperEdge maintainer. According to the degree of PR contribution, the project leader will vote for all projects to decide whether to become a maintainer, announce it at the community meeting, and add it to the list of maintainers.

-   Become a Reviewer

    After the number of PRs submitted by a component is greater than 3, you can contact the project leader to see if you can become a module maintainer. According to the degree of PR contribution, the project leader will be voted by all project leaders to decide whether they can become a Reviewer, which will be announced at the community meeting and added to the Reviewer list.

-   Become a volunteer

    The volunteers of the project give priority to the project, assist the maintainer and the Reviewer in the work, and the PR contributed by them has priority access rights. You can contact the project leader to join the project volunteer exchange group.

-   Organize cooperation and exchanges

    Companies and organizations that want to cooperate with the SuperEdge project can directly contact the person in charge of the SuperEdge project for communication and cooperation. You can also ask related questions at community meetings.

## Other projects

The SuperEdge organization is open to accepting new sub-projects under its umbrella. To accept a project into the SuperEdge organization, it must meet the following criteria:

-   Must be licensed under the terms of Apache License v2.0
-   Must be related to one or more scopes of the SuperEdge ecosystem:
    -   SuperEdge project artifacts and direction
    -   Other edge computing related
-   Must be supported by maintainers unrelated to or affiliated with the sub-project author

The submission process starts with a pull request or question on the [superedge/superedge](https://github.com/superedge/superedge) repository, which contains the required information above. Once the project is accepted, it will be treated as a CNCF sub-project under the superedge umbrella.

## SuperEdge and CNCF

SuperEdge is a CNCF project. Therefore, SuperEdge may participate in CNCF (or other CNCF projects) related marketing, events or activities. Any maintainer can help promote SuperEdge participation, as long as the SuperEdge project leader sends an email to call on other maintainers to participate. The `Call for Participation` should remain open for no less than a week. If time permits, it is still a *reasonable* time frame to give maintainers the opportunity to volunteer.

## Code of Conduct

The [Code of Conduct SuperEdge](https://github.com/superedge/superedge/blob/main/CODE_OF_CONDUCT.md) is aligned with the CNCF Code of Conduct.

