/*
Copyright 2021 The SuperEdge authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	appsv1 "github.com/superedge/superedge/pkg/apps-manager/apis/apps/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeEDeployments implements EDeploymentInterface
type FakeEDeployments struct {
	Fake *FakeAppsV1
	ns   string
}

var edeploymentsResource = schema.GroupVersionResource{Group: "apps.superedge.io", Version: "v1", Resource: "edeployments"}

var edeploymentsKind = schema.GroupVersionKind{Group: "apps.superedge.io", Version: "v1", Kind: "EDeployment"}

// Get takes name of the eDeployment, and returns the corresponding eDeployment object, and an error if there is any.
func (c *FakeEDeployments) Get(ctx context.Context, name string, options v1.GetOptions) (result *appsv1.EDeployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(edeploymentsResource, c.ns, name), &appsv1.EDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*appsv1.EDeployment), err
}

// List takes label and field selectors, and returns the list of EDeployments that match those selectors.
func (c *FakeEDeployments) List(ctx context.Context, opts v1.ListOptions) (result *appsv1.EDeploymentList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(edeploymentsResource, edeploymentsKind, c.ns, opts), &appsv1.EDeploymentList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &appsv1.EDeploymentList{ListMeta: obj.(*appsv1.EDeploymentList).ListMeta}
	for _, item := range obj.(*appsv1.EDeploymentList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested eDeployments.
func (c *FakeEDeployments) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(edeploymentsResource, c.ns, opts))

}

// Create takes the representation of a eDeployment and creates it.  Returns the server's representation of the eDeployment, and an error, if there is any.
func (c *FakeEDeployments) Create(ctx context.Context, eDeployment *appsv1.EDeployment, opts v1.CreateOptions) (result *appsv1.EDeployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(edeploymentsResource, c.ns, eDeployment), &appsv1.EDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*appsv1.EDeployment), err
}

// Update takes the representation of a eDeployment and updates it. Returns the server's representation of the eDeployment, and an error, if there is any.
func (c *FakeEDeployments) Update(ctx context.Context, eDeployment *appsv1.EDeployment, opts v1.UpdateOptions) (result *appsv1.EDeployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(edeploymentsResource, c.ns, eDeployment), &appsv1.EDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*appsv1.EDeployment), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeEDeployments) UpdateStatus(ctx context.Context, eDeployment *appsv1.EDeployment, opts v1.UpdateOptions) (*appsv1.EDeployment, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(edeploymentsResource, "status", c.ns, eDeployment), &appsv1.EDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*appsv1.EDeployment), err
}

// Delete takes name of the eDeployment and deletes it. Returns an error if one occurs.
func (c *FakeEDeployments) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(edeploymentsResource, c.ns, name), &appsv1.EDeployment{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeEDeployments) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(edeploymentsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &appsv1.EDeploymentList{})
	return err
}

// Patch applies the patch and returns the patched eDeployment.
func (c *FakeEDeployments) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *appsv1.EDeployment, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(edeploymentsResource, c.ns, name, pt, data, subresources...), &appsv1.EDeployment{})

	if obj == nil {
		return nil, err
	}
	return obj.(*appsv1.EDeployment), err
}
